#include "StdAfx.h"
#include "DataInMem.h"

/*
DataInMem 

psrc  ּ, size ũ Ѵ.
*/
DataInMem::DataInMem(void* psrc, size_t size) : m_psrc((char*)psrc), m_size(size), m_pointer(0)
{
	
}


/*
DataInMem::read(void* dest, size_t n)

޸𸮿 nƮ о dest Ѵ.
 Ʈ ȯѴ.
*/
size_t DataInMem::read(void* dest, size_t n)
{
	if(m_pointer>m_size)return 0;
	if(m_pointer+n>m_size)n=m_size-m_pointer;
	memcpy(dest, m_psrc+m_pointer, n);
	m_pointer+=n;
	return n;
}

/*
DataInMem::write(const void* src, size_t n)

src nƮ о ޸𸮿 .
 Ʈ ȯѴ.
*/
size_t DataInMem::write(const void* src, size_t n)
{
	if(m_pointer>m_size)return 0;
	if(m_pointer+n>m_size)n=m_pointer-m_size;
	memcpy(m_psrc, src, n);
	m_pointer+=n;
	return n;
}

/*
DataInMem::seek(int offset, int whence)

͸ յڷ δ. (fseek )
*/
int DataInMem::seek(int offset, int whence)
{
	switch(whence)
	{
	case SEEK_SET:
		if(offset<0)
			m_pointer=0;
		else if((size_t)offset>=m_size)
			m_pointer=m_size;
		else
			m_pointer=offset;
		return 0;
	case SEEK_CUR:
		if(m_pointer+offset<0)
			m_pointer=0;
		else if(m_pointer+offset>=m_size)
			m_pointer=m_size;
		else
			m_pointer+=offset;
		return 0;
	case SEEK_END:
		if(m_size+offset<0)
			m_pointer=0;
		else if(m_size+offset>=m_size)
			m_pointer=m_size;
		else 
			m_pointer=m_size+offset;
		return 0;
	}
	return -1;
}

/*
DataInMem::tell()

  ġ ȯѴ.
*/
size_t DataInMem::tell()
{
	return m_pointer;
}

/*
DataInMem::getsize()

޸ ũ⸦ ȯѴ.
*/
size_t DataInMem::getsize()
{
	return m_size;
}

/*
DataInMem::getsrc()

޸  ּҸ ȯѴ.
*/
const void* DataInMem::getsrc()
{
	return m_psrc;
}



/*
DataInFile 

hFile Ű  ޸𸮿 Ѵ.
*/
DataInFile::DataInFile(HANDLE hFile, DWORD access) : DataInMem(NULL, 0), m_access(access)
{
	m_size=GetFileSize(hFile, NULL);
	m_hFileMap=CreateFileMapping(hFile, NULL, 
		m_access==readonly ? PAGE_READONLY : PAGE_READWRITE,
		0, (DWORD)m_size, NULL);
	if(m_hFileMap==NULL)
	{
		m_size=0;
		return;
	}
	m_psrc=(char*)MapViewOfFile(m_hFileMap, 
		m_access==readonly ? FILE_MAP_READ : FILE_MAP_ALL_ACCESS,
		0, 0, 0);
	if(!m_psrc)
	{
		CloseHandle(m_hFileMap);
		m_hFileMap=NULL;
		m_size=0;
		return;
	}
}

/*
DataInFile Ҹ

޸𸮿 Ѱ ݵ ؾ Ѵ.
*/
DataInFile::~DataInFile()
{
	if(m_hFileMap)
	{
		CloseHandle(m_hFileMap);
		m_hFileMap=NULL;
	}
}

/*
DataInFile::write(const void* src, size_t n)

DataInMem ӹ Լ, б  쿡
͸ (write) ȵǹǷ 0 ϰ,
 ܿ DataInMem::write ȣѴ.
*/
size_t DataInFile::write(const void* src, size_t n)
{
	if(m_access==readonly) return 0;
	return DataInMem::write(src, n);
}

/*
DataInFileDirect 

name:   ̸/ּ
access: DataInFile  ٹ

   DataInFile ڿ handle Ѵ.
*/
DataInFileDirect::DataInFileDirect(LPCWSTR name, DWORD access) :
	DataInFile(m_hFile=CreateFileW(name, access==readonly ? GENERIC_READ : GENERIC_READ | GENERIC_WRITE,
	0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL), access)
{
	if(m_hFile==INVALID_HANDLE_VALUE)
	{
		m_hFile=NULL;
	}
}

DataInFileDirect::DataInFileDirect(LPCSTR name, DWORD access) :
	DataInFile(m_hFile=CreateFileA(name, access==readonly ? GENERIC_READ : GENERIC_READ | GENERIC_WRITE,
	0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL), access)
{
	if(m_hFile==INVALID_HANDLE_VALUE)
	{
		m_hFile=NULL;
	}
}

/*
DataInFileDirect Ҹ

  ݵ ݾ Ѵ.
*/
DataInFileDirect::~DataInFileDirect()
{
	if(m_hFile)
	{
		CloseHandle(m_hFile);
	}
}