#include "StdAfx.h"
#include "Comm.h"
#include "GFont.h"

/*
GFont 
*/
GFont::GFont()
{
	memset(m_cd, 0, sizeof(m_cd));
}

/*
GFont::GetSprites()

GFont  ִ
GSprites νϽ ּҸ ȯѴ.
*/
GSprites* GFont::GetSprites()
{
	return &m_sprs;
}

/*
GFont::Draw(LPCWSTR str, RECT* pr, DWORD align, float s, D3DCOLOR color) const

Ǿ ִ   ڿ ȭ鿡 ׸.
str : ׸ ڿ
pr : ڿ ׸ 簢 ּ
align : ڿ  
s :  ũ. 1 ⺻ ũ.
color : ڿ 
*/
GRET GFont::Draw(LPCWSTR str, RECT* pr, DWORD align, float s, D3DCOLOR color) const
{
	RECT size=CalcSize(str, s);
	int x, y;
	switch(align & align_horizon_flags)
	{
	case align_center:
		x=pr->left+(rect_width(*pr)-size.right)/2;
		break;
	case align_right:
		x=pr->right-size.right;
		break;
	default:
		x=pr->left;
		break;
	}
	switch(align & align_vertical_flags)
	{
	case align_vcenter:
		y=pr->top+(rect_height(*pr)-size.bottom)/2;
		break;
	case align_bottom:
		y=pr->bottom-size.bottom;
		break;
	default:
		y=pr->top;
		break;
	}
	vector<int> ys;
	ys.push_back((int)(m_cd[0].height*s));
	while(*str)
	{
		if(*str==L'\n')
		{
			y+=*max_element(ys.begin(), ys.end());
			ys.clear();
		}
		else if(*str==L' ')
		{
			x+=(UINT)(m_cd[0].width*s);
			ys.push_back((int)(m_cd[0].height*s));
		}
		else if(*str<128)
		{
			GRET r=m_sprs.DrawSprite(m_cd[*str-32].sprindex, x, y, s, s, color);
			if(r!=GRET_OK)return r;
			x+=(UINT)(m_cd[*str-32].width*s);
			ys.push_back((int)(m_cd[*str-32].height*s));
		}
		str++;
	}
	return GRET_OK;
}

/*
GFont::Draw(int i, RECT* pr, DWORD align, float s, D3DCOLOR color) const

Ǿ ִ   ڸ ȭ鿡 ׸.

i : ׸ 
pr : ڸ ׸ 簢 ּ
align :  
s :  ũ. 1 ⺻
color :  
*/
GRET GFont::Draw(int i, RECT* pr, DWORD align, float s, D3DCOLOR color) const
{
	wchar_t str[32];
	swprintf(str, 32, L"%d", i);
	return Draw(str, pr, align, s, color);
}

/*
GFont::SetCharDat(wchar_t c, UINT sprindex, UINT width, UINT height)

  Ѵ.

c :   
sprindex : ڰ  Ʈ ȣ
width :   
height :   
*/
GRET GFont::SetCharDat(wchar_t c, UINT sprindex, UINT width, UINT height)
{
	if(c<L' ')return GRET_ERROR_PARAM;
	if(c>=128)return GRET_ERROR_PARAM;
	m_cd[c-32].sprindex=sprindex;
	m_cd[c-32].width=width;
	m_cd[c-32].height=height;
	return GRET_OK;
}

/*
GFont::CalcSize(LPCWSTR str, float s) const

ڿ ׷ ũ⸦ Ѵ.

str : ũ⸦  ڿ
s :  ũ. 1 ⺻ ũ.
*/
RECT GFont::CalcSize(LPCWSTR str, float s) const
{
	vector<int> xs;
	xs.push_back(0);
	int y=0;
	vector<int> ys;
	ys.push_back((int)(m_cd[0].height*s));
	while(*str)
	{
		if(*str==L'\n')
		{
			xs.push_back(0);
			y+=*max_element(ys.begin(), ys.end());
			ys.clear();
		}
		else if(*str==L' ')
		{
			xs.back()+=(UINT)(m_cd[0].width*s);
			ys.push_back((int)(m_cd[0].height*s));
		}
		else if(*str<128)
		{
			xs.back()+=(UINT)(m_cd[*str-32].width*s);
			ys.push_back((int)(m_cd[*str-32].height*s));
		}
		str++;
	}
	y+=*max_element(ys.begin(), ys.end());
	RECT r={0, 0, *max_element(xs.begin(), xs.end()), y};
	return r;
}
