#include "StdAfx.h"
#include "Comm.h"
#include "GGame.h"
#include "GObject.h"


/*
GObject 
*/
GObject::GObject() : m_pcodedata(NULL), m_address(0)
{
}

/*
GObject Ҹ
*/
GObject::~GObject()
{
}

/*
GObject::Init(const BYTE* codedata)

 ׸ ڵ ּ codedata ϸ ׸ ü ʱȭѴ.
*/
void GObject::Init(const BYTE* codedata)
{
	m_pcodedata=codedata;
}


/*
GObject::Jump(WORD address)

address Ѵ.
*/
void GObject::Jump(WORD address)
{
	m_address=address;
}

/*
GObject::IsEmpty()

׸ ü  (ʱȭ  ʾ , ҸǾ )
true Ѵ.
*/
bool GObject::IsEmpty()
{
	return m_pcodedata==NULL;
}

/*
GObject::End()

׸ ü ҸŲ.
*/
void GObject::End()
{
	m_pcodedata=NULL;
}

/*
׸ ڵ ɾ Ʈ

setdata(byte index, long x, long y)
: indexȣ ͸ (x, y) Ѵ.
draw(word index, short x, short y, dword color)
: indexȣ Ʈ (x, y) color  ׸.
draws(word index, short x, short y, float sx, floay sy, dword color)
: indexȣ Ʈ (x, y) (sx, sy) ÷ color ׸.
drawr(word index, short x, short y, float rot, dword color)
: indexȣ Ʈ (x, y) rot()ŭ ȸؼ color ׸.
drawsr(word index, short x, short y, float sx, float sy, float rot, dword color)
: indexȣ Ʈ (x, y) (sx, sy) ø rot()ŭ ȸؼ color ׸.
setdrawmode(byte mode, byte channel)
: ׸带 mode, ä channel Ѵ.
goto(word address)
: address ּҷ Ѵ.
randomjump(byte prob, word address)
: prob/255  Ȯ address Ѵ.
frameend()
: ׸⸦ . ()
end()
: ׸⸦ . (ü)
setcount()
: ī͸ 0 Ѵ.
inccount()
: ī͸ 1 Ѵ.
countjump(byte limit, word address)
: īͰ limit  address Ѵ.
drawvh(word index, short x, short y, short w, short h, dword color)
: indexȣ Ʈ (x, y) (w, h+vdata) ũ ÷ color ׸.
drawvy(word index, short x, short y, short sx, short sy, short w, short h, dword color)
: indexȣ Ʈ (sx, sy+vdata) (x, y+vdata) (w, h) ũ ÷ color ׸.
drawcombo(short left, short top, short right, short bottom, word align, float s, dword color)
: s ũ combo ؽƮ (left, top, right, bottom) 簢 align Ͽ color ׸.
drawline(short x1, short y1, short x2, short y2, dword color)
: (x1, y1)-(x2, y2)  color ׸.
*/

/*
GObject::Proc(const GSprites* sprs, const GFont* font, POINT offset, POINT* data, int vdata)

׸ ڵ带 Ѵ.
game DrawSprite, SetDrawMode  Լ ȣϸ ׸⸦ Ѵ.
ü ׸  offsetŭ ̵Ͽ ׸.
data GO_SetData   ̴.
vdata GO_DrawVH GO_DrawVY, GO_DrawCombo  Ͱ̴.
*/
int GObject::Proc(const GSprites* sprs, const GFont* font, POINT offset, POINT* data, int vdata)
{
	if(!m_pcodedata)return -1;
	while(1)
	{
		switch(m_pcodedata[m_address++])
		{
		case GO_SetData:
			{
				BYTE index=m_pcodedata[m_address++];
				data[index]=*(POINT*)(m_pcodedata+m_address);
				m_address+=sizeof(POINT);
			}
			break;
		case GO_Draw:
			{
				WORD index=*(WORD*)(m_pcodedata+m_address);
				m_address+=2;
				short x=*(short*)(m_pcodedata+m_address);
				m_address+=2;
				short y=*(short*)(m_pcodedata+m_address);
				m_address+=2;
				DWORD color=*(DWORD*)(m_pcodedata+m_address);
				m_address+=4;
				if(sprs)
					sprs->DrawSprite(index, x+offset.x, y+offset.y, color);
			}
			break;
		case GO_DrawS:
			{
				WORD index=*(WORD*)(m_pcodedata+m_address);
				m_address+=2;
				short x=*(short*)(m_pcodedata+m_address);
				m_address+=2;
				short y=*(short*)(m_pcodedata+m_address);
				m_address+=2;
				float sx=*(float*)(m_pcodedata+m_address);
				m_address+=4;
				float sy=*(float*)(m_pcodedata+m_address);
				m_address+=4;
				DWORD color=*(DWORD*)(m_pcodedata+m_address);
				m_address+=4;
				if(sprs)
					sprs->DrawSprite(index, x+offset.x, y+offset.y, sx, sy, color);
			}
			break;
		case GO_DrawR:
			{
				WORD index=*(WORD*)(m_pcodedata+m_address);
				m_address+=2;
				short x=*(short*)(m_pcodedata+m_address);
				m_address+=2;
				short y=*(short*)(m_pcodedata+m_address);
				m_address+=2;
				float rot=*(float*)(m_pcodedata+m_address);
				m_address+=4;
				DWORD color=*(DWORD*)(m_pcodedata+m_address);
				m_address+=4;
				if(sprs)
					sprs->DrawSprite(index, x+offset.x, y+offset.y, rot, color);
			}
			break;
		case GO_DrawSR:
			{
				WORD index=*(WORD*)(m_pcodedata+m_address);
				m_address+=2;
				short x=*(short*)(m_pcodedata+m_address);
				m_address+=2;
				short y=*(short*)(m_pcodedata+m_address);
				m_address+=2;
				float sx=*(float*)(m_pcodedata+m_address);
				m_address+=4;
				float sy=*(float*)(m_pcodedata+m_address);
				m_address+=4;
				float rot=*(float*)(m_pcodedata+m_address);
				m_address+=4;
				DWORD color=*(DWORD*)(m_pcodedata+m_address);
				m_address+=4;
				if(sprs)
					sprs->DrawSprite(index, x+offset.x, y+offset.y, sx, sy, rot, color);
			}
			break;
		case GO_SetDrawMode:
			{
				BYTE mode=m_pcodedata[m_address++];
				BYTE channel=m_pcodedata[m_address++];
				if(sprs)
					GGame::GetInstance()->SetDrawMode(mode, channel);
			}
			break;
		case GO_Goto:
			{
				WORD address=*(WORD*)(m_pcodedata+m_address);
				m_address=address;
			}
			break;
		case GO_RandomJump:
			{
				BYTE prob=m_pcodedata[m_address++];
				WORD address=*(WORD*)(m_pcodedata+m_address);
				m_address+=2;
				if((rand() & 256) <= prob)m_address=address;
			}
			break;
		case GO_FrameEnd:
			return 0;
		case GO_End:
			End();
			return 1;
		case GO_SetCount:
			m_count=0;
			break;
		case GO_IncCount:
			m_count++;
			break;
		case GO_CountJump:
			{
				BYTE limit=m_pcodedata[m_address++];
				WORD address=*(WORD*)(m_pcodedata+m_address);
				m_address+=2;
				if(m_count < limit)m_address=address;
			}
			break;
		case GO_DrawVH:
			{
				WORD index=*(WORD*)(m_pcodedata+m_address);
				m_address+=2;
				short x=*(short*)(m_pcodedata+m_address);
				m_address+=2;
				short y=*(short*)(m_pcodedata+m_address);
				m_address+=2;
				short sw=*(short*)(m_pcodedata+m_address);
				m_address+=2;
				short sh=*(short*)(m_pcodedata+m_address);
				m_address+=2;
				DWORD color=*(DWORD*)(m_pcodedata+m_address);
				m_address+=4;
				if(sprs)
					sprs->DrawSprite(index, x+offset.x, y+offset.y, sw, sh+vdata, color);
			}
			break;
		case GO_DrawVY:
			{
				WORD index=*(WORD*)(m_pcodedata+m_address);
				m_address+=2;
				short x=*(short*)(m_pcodedata+m_address);
				m_address+=2;
				short y=*(short*)(m_pcodedata+m_address);
				m_address+=2;
				short sx=*(short*)(m_pcodedata+m_address);
				m_address+=2;
				short sy=*(short*)(m_pcodedata+m_address);
				m_address+=2;
				short w=*(short*)(m_pcodedata+m_address);
				m_address+=2;
				short h=*(short*)(m_pcodedata+m_address);
				m_address+=2;
				DWORD color=*(DWORD*)(m_pcodedata+m_address);
				m_address+=4;
				if(sprs)
					sprs->DrawSprite(index, x+offset.x, y+offset.y+vdata, w, h, sx, sy+vdata, color);
			}
			break;
		case GO_DrawCombo:
			{
				short left=*(short*)(m_pcodedata+m_address);
				m_address+=2;
				short top=*(short*)(m_pcodedata+m_address);
				m_address+=2;
				short right=*(short*)(m_pcodedata+m_address);
				m_address+=2;
				short bottom=*(short*)(m_pcodedata+m_address);
				m_address+=2;
				WORD align=*(WORD*)(m_pcodedata+m_address);
				m_address+=2;
				float s=*(float*)(m_pcodedata+m_address);
				m_address+=4;
				DWORD color=*(DWORD*)(m_pcodedata+m_address);
				m_address+=4;
				RECT r={left+offset.x, top+offset.y, right+offset.x, bottom+offset.y};
				if(font)
					font->Draw(vdata, &r, align, s, color);
			}
			break;
		case GO_DrawLine:
			{
				short x1=*(short*)(m_pcodedata+m_address);
				m_address+=2;
				short y1=*(short*)(m_pcodedata+m_address);
				m_address+=2;
				short x2=*(short*)(m_pcodedata+m_address);
				m_address+=2;
				short y2=*(short*)(m_pcodedata+m_address);
				m_address+=2;
				DWORD color=*(DWORD*)(m_pcodedata+m_address);
				m_address+=4;
				if(sprs)
				{
					GGame::GetInstance()->DrawLine(x1+offset.x, y1+offset.y,
						x2+offset.x, y2+offset.y, color);
				}
			}
			break;
		}
	}
}