#include "StdAfx.h"
#include "Comm.h"
#include "GGame.h"

#include "MPlayGame.h"
#include "GStrings.h"

/*
MPlayGame 
*/
MPlayGame::MPlayGame()
{
	GStrings strs;
	strs.Load(&DataInFileDirect(L"textures.str"));
	for(size_t i=0;i<strs.size();i++)
	{
		m_sprs.LoadTexture(&DataInFileDirect(strs[i].c_str()));
	}
	m_sprs.LoadSprites(&DataInFileDirect(L"sprites.dat"));

	m_gfont.GetSprites()->LoadTexture(&DataInFileDirect(L"font.png"));
	m_gfont.GetSprites()->LoadSprites(&DataInFileDirect(L"fontsprites.dat"));
	for(int i=0;i<10;i++)
	{
		m_gfont.SetCharDat(L'0'+i, i, 50, 64);
	}

	LoadOC(&DataInFileDirect(L"script.goc"));
	m_objframe.Init(&m_codedata[0]);
	m_objframe.Jump(Event_Frame*3);
	m_ui.frame.x=60;
	m_ui.frame.y=0;
	m_objframe.Proc(NULL, NULL, m_ui.frame, m_ui.key, 0);
	m_hpbar.Init(&m_codedata[0]);
	m_hpbar.Jump(Event_HPBar*3);
	
	m_buttonkeycode[0]=L'D';
	m_buttonkeycode[1]=L'F';
	m_buttonkeycode[2]=VK_SPACE;
	m_buttonkeycode[3]=L'J';
	m_buttonkeycode[4]=L'K';

	m_hp=m_maxhp=10000;
}

/*
MPlayGame Ҹ
*/
MPlayGame::~MPlayGame()
{
}

/*
MPlayGame::LoadOC(DataInMem* file)

file ׸ڵ带 о´.
*/
GRET MPlayGame::LoadOC(DataInMem* file)
{
	size_t fsize=file->getsize();
	m_codedata.resize(fsize);
	if(fsize)file->read(&m_codedata[0], fsize);
	return 0;
}


/*
MPlayGame::GetButton(int KeyCode)

KeyCode  ư شϴ  Ͽ Ѵ.
 Ű ش   -1 Ѵ.
*/
int MPlayGame::GetButton(int KeyCode)
{
	for(int i=0;i<5;i++)
	{
		if(m_buttonkeycode[i]==KeyCode)return i;
	}
	return -1;
}

/*
MPlayGame::OnCreate()

MState::OnCreate()  
*/
void MPlayGame::OnCreate()
{
}

/*
MPlayGame::OnProc()

MState::OnProc()   
*/
void MPlayGame::OnProc(DWORD ElapsedTime)
{
}

/*
MPlayGame::OnKeyDown(int KeyCode)

MState::OnKeyDown(int KeyCode)  
*/
void MPlayGame::OnKeyDown(int KeyCode)
{
	int ibut=GetButton(KeyCode);
	if(ibut>=0)return ButtonDown(ibut);
}

/*
MPlayGame::OnKeyUp(int KeyCode)

MState::OnKeyUp(int KeyCode)  
*/
void MPlayGame::OnKeyUp(int KeyCode)
{
	int ibut=GetButton(KeyCode);
	if(ibut>=0)return ButtonUp(ibut);
}

/*
MPlayGame::OnDraw()

MState::OnDraw()  
*/
void MPlayGame::OnDraw()
{
	m_objframe.Proc(&m_sprs, &m_gfont, m_ui.frame, m_ui.key, 0);
	float fhp=(float)m_hp/m_maxhp;
	m_hpbar.Proc(&m_sprs, &m_gfont, m_ui.frame+m_ui.hpbar, NULL, 
		m_ui.hpbarminmax.x+(int)(fhp*(m_ui.hpbarminmax.y-m_ui.hpbarminmax.x)));
	for(int i=0;i<5;i++)
	{
		m_button[i].Proc(&m_sprs, &m_gfont, m_ui.frame+m_ui.key[i], NULL, 0);
	}
	RECT r={0, 0, 400, 60};
	m_gfont.Draw(1234567890, &r, GFont::align_left | GFont::align_top);
}

/*
MPlayGame::OnPostProc()

MState::OnPostProc()  
*/
void MPlayGame::OnPostProc()
{
}

/*
MPlayGame::OnLost()

MState::OnLost()  
*/
void MPlayGame::OnLost()
{
}

/*
MPlayGame::OnReset()

MState::OnReset()  
*/
void MPlayGame::OnReset()
{
}

/*
MPlayGame::OnDrawSkip()

MState::OnDrawSkip()  
*/
void MPlayGame::OnDrawSkip()
{
}

/*
MPlayGame::ButtonDown(int Button)

Buttonȣ ư  ȣȴ.
ưƮ ׸ ü ʱȭѴ.
*/
void MPlayGame::ButtonDown(int Button)
{
	m_button[Button].Init(&m_codedata[0]);
	m_button[Button].Jump((Event_Button1Down+Button)*3);
}

/*
MPlayGame::ButtonUp(int Button)

Buttonȣ ư   ȣȴ.
ưƮ ׸ ü Ѵ.
*/
void MPlayGame::ButtonUp(int Button)
{
	m_button[Button].Jump((Event_Button1Up+Button)*3);
}
